C Copyright 1981-2007 ECMWF
C 
C Licensed under the GNU Lesser General Public License which
C incorporates the terms and conditions of version 3 of the GNU
C General Public License.
C See LICENSE and gpl-3.0.txt for details.
C

      SUBROUTINE BUUNP(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)
C
C**** *BUUNP*
C
C
C     PURPOSE.
C     --------
C          PURPOSE OF THIS ROUTINE IS TO UNPACK BIT STRING OF
C     KSIZE BITS, STARTED AT WORD KWPT OF ARRAY KSOURC AFTER
C     SKIPPING KBPT BITS. RESULT IS PUT INTO KDEST.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *BUUNP(KBPW,KSOURC,KDEST,KWPT,KBPT,KSIZE,KERR)*
C
C        INPUT :
C                 *KBPW*      - NUMBER OF BITS IN COMPUTER WORD
C                 *KSOURC*    - SOURCE (CONTINUOUS BIT STRING OF
C                               ARBITRARY LENGTH)
C                 *KWPT*      - WORD POINTER
C                 *KBPT*      - BIT POINTER
C                 *KSIZE*     - NUMBER OF BITS TO BE EXTRACTED
C        OUTPUT:
C                 *KDEST*     - DESTINATION
C                 *KERR*      - RETURN ERROR CODE
C
C     METHOD.
C     -------
C
C            NONE.
C
C
C     EXTERNALS.
C     ----------
C
C
C          GBYTE     - UNPACK BIT PATTERN
C
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/01/91.
C
C
C     MODIFICATIONS.
C     --------------
C
C          NONE.
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION KSOURC(*)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT BIT PATTERN.
C                --------------------
 100  CONTINUE
C
      IF(KERR.GT.0) RETURN
C
      IF(KSIZE.GT.KBPW) THEN
         KERR=13
         WRITE(KNTN,*)' BUUNP :'
         CALL BUERR(KERR)
         RETURN
      END IF
C
      CALL GBYTE(KSOURC(KWPT),KDEST,KBPT,KSIZE)
C
      RETURN
      END
